Index: uspace/lib/c/generic/inet/addr.c
===================================================================
--- uspace/lib/c/generic/inet/addr.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/generic/inet/addr.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2013 Martin Decky
  * All rights reserved.
  *
@@ -36,7 +37,5 @@
 #include <errno.h>
 #include <unistd.h>
-#include <net/socket_codes.h>
 #include <inet/addr.h>
-#include <net/inet.h>
 #include <stdio.h>
 #include <malloc.h>
@@ -44,4 +43,6 @@
 
 #define INET_PREFIXSTRSIZE  5
+
+#define INET6_ADDRSTRLEN (8 * 4 + 7 + 1)
 
 #if !(defined(__BE__) ^ defined(__LE__))
@@ -180,59 +181,4 @@
 }
 
-/** Determine address version.
- *
- * @param text Address in common notation.
- * @param af   Place to store address version.
- *
- * @return EOK on success, EINVAL if input is not in valid format.
- *
- */
-static int inet_addr_version(const char *text, ip_ver_t *ver)
-{
-	char *dot = str_chr(text, '.');
-	if (dot != NULL) {
-		*ver = ip_v4;
-		return EOK;
-	}
-
-	char *collon = str_chr(text, ':');
-	if (collon != NULL) {
-		*ver = ip_v6;
-		return EOK;
-	}
-
-	return EINVAL;
-}
-
-static int ipver_af(ip_ver_t ver)
-{
-	switch (ver) {
-	case ip_any:
-		return AF_NONE;
-	case ip_v4:
-		return AF_INET;
-	case ip_v6:
-		return AF_INET6;
-	default:
-		assert(false);
-		return EINVAL;
-	}
-}
-
-ip_ver_t ipver_from_af(int af)
-{
-	switch (af) {
-	case AF_NONE:
-		return ip_any;
-	case AF_INET:
-		return ip_v4;
-	case AF_INET6:
-		return ip_v6;
-	default:
-		assert(false);
-		return EINVAL;
-	}
-}
-
 void inet_naddr_addr(const inet_naddr_t *naddr, inet_addr_t *addr)
 {
@@ -288,5 +234,5 @@
 	if (naddr->version != addr->version)
 		return 0;
-	
+
 	switch (naddr->version) {
 	case ip_v4:
@@ -315,5 +261,5 @@
 		if (naddr->prefix > 128)
 			return 0;
-		
+
 		size_t pos = 0;
 		for (size_t i = 0; i < 16; i++) {
@@ -321,5 +267,5 @@
 			if (naddr->prefix < pos)
 				break;
-			
+
 			if (naddr->prefix - pos > 8) {
 				/* Comparison without masking */
@@ -333,8 +279,8 @@
 					return 0;
 			}
-			
+
 			pos += 8;
 		}
-		
+
 		return 1;
 	default:
@@ -343,4 +289,137 @@
 }
 
+static int inet_addr_parse_v4(const char *str, inet_addr_t *raddr,
+    int *prefix)
+{
+	uint32_t a = 0;
+	uint8_t b;
+	char *cur = (char *)str;
+	size_t i = 0;
+
+	while (i < 4) {
+		int rc = str_uint8_t(cur, (const char **)&cur, 10, false, &b);
+		if (rc != EOK)
+			return rc;
+
+		a = (a << 8) + b;
+
+		i++;
+
+		if (*cur == '\0')
+			break;
+
+		if (*cur != '.')
+			return EINVAL;
+
+		if (i < 4)
+			cur++;
+	}
+
+	if (prefix != NULL) {
+		*prefix = strtoul(cur, &cur, 10);
+		if (*prefix > 32)
+			return EINVAL;
+	}
+
+	if (i != 4 || (*cur != '\0'))
+		return EINVAL;
+
+	raddr->version = ip_v4;
+	raddr->addr = a;
+
+	return EOK;
+}
+
+static int inet_addr_parse_v6(const char *str, inet_addr_t *raddr, int *prefix)
+{
+	uint8_t data[16];
+
+	memset(data, 0, 16);
+
+	const char *cur = str;
+	size_t i = 0;
+	size_t wildcard_pos = (size_t) -1;
+	size_t wildcard_size = 0;
+
+	/* Handle initial wildcard */
+	if ((str[0] == ':') && (str[1] == ':')) {
+		cur = str + 2;
+		wildcard_pos = 0;
+		wildcard_size = 16;
+
+		/* Handle the unspecified address */
+		if (*cur == '\0')
+			goto success;
+	}
+
+	while (i < 16) {
+		uint16_t bioctet;
+		int rc = str_uint16_t(cur, &cur, 16, false, &bioctet);
+		if (rc != EOK)
+			return rc;
+
+		data[i] = (bioctet >> 8) & 0xff;
+		data[i + 1] = bioctet & 0xff;
+
+		if (wildcard_pos != (size_t) -1) {
+			if (wildcard_size < 2)
+				return EINVAL;
+
+			wildcard_size -= 2;
+		}
+
+		i += 2;
+
+		if (*cur != ':')
+			break;
+
+		if (i < 16) {
+			cur++;
+
+			/* Handle wildcard */
+			if (*cur == ':') {
+				if (wildcard_pos != (size_t) -1)
+					return EINVAL;
+
+				wildcard_pos = i;
+				wildcard_size = 16 - i;
+				cur++;
+
+				if (*cur == '\0' || *cur == '/')
+					break;
+			}
+		}
+	}
+
+	if (prefix != NULL) {
+		if (*cur != '/')
+			return EINVAL;
+		cur++;
+
+		*prefix = strtoul(cur, (char **)&cur, 10);
+		if (*prefix > 128)
+			return EINVAL;
+	}
+
+	if (*cur != '\0')
+		return EINVAL;
+
+	/* Create wildcard positions */
+	if ((wildcard_pos != (size_t) -1) && (wildcard_size > 0)) {
+		size_t wildcard_shift = 16 - wildcard_size;
+
+		for (i = wildcard_pos + wildcard_shift; i > wildcard_pos; i--) {
+			size_t j = i - 1;
+			data[j + wildcard_size] = data[j];
+			data[j] = 0;
+		}
+	}
+
+success:
+	raddr->version = ip_v6;
+	memcpy(raddr->addr6, data, 16);
+	return EOK;
+}
+
 /** Parse node address.
  *
@@ -353,26 +432,15 @@
 int inet_addr_parse(const char *text, inet_addr_t *addr)
 {
-	int rc = inet_addr_version(text, &addr->version);
-	if (rc != EOK)
-		return rc;
-	
-	uint8_t buf[16];
-	rc = inet_pton(ipver_af(addr->version), text, buf);
-	if (rc != EOK)
-		return rc;
-	
-	switch (addr->version) {
-	case ip_v4:
-		addr->addr = (buf[0] << 24) | (buf[1] << 16) | (buf[2] << 8) |
-		    buf[3];
-		break;
-	case ip_v6:
-		memcpy(addr->addr6, buf, 16);
-		break;
-	default:
-		return EINVAL;
-	}
-	
-	return EOK;
+	int rc;
+
+	rc = inet_addr_parse_v4(text, addr, NULL);
+	if (rc == EOK)
+		return EOK;
+
+	rc = inet_addr_parse_v6(text, addr, NULL);
+	if (rc == EOK)
+		return EOK;
+
+	return EINVAL;
 }
 
@@ -387,48 +455,97 @@
 int inet_naddr_parse(const char *text, inet_naddr_t *naddr)
 {
-	char *slash = str_chr(text, '/');
-	if (slash == NULL)
-		return EINVAL;
-	
-	*slash = 0;
-	
-	int rc = inet_addr_version(text, &naddr->version);
-	if (rc != EOK)
-		return rc;
-	
-	uint8_t buf[16];
-	rc = inet_pton(ipver_af(naddr->version), text, buf);
-	*slash = '/';
-	
-	if (rc != EOK)
-		return rc;
-	
-	slash++;
-	uint8_t prefix;
-	
-	switch (naddr->version) {
-	case ip_v4:
-		prefix = strtoul(slash, &slash, 10);
-		if (prefix > 32)
+	int rc;
+	inet_addr_t addr;
+	int prefix;
+
+	rc = inet_addr_parse_v4(text, &addr, &prefix);
+	if (rc == EOK) {
+		inet_addr_naddr(&addr, prefix, naddr);
+		return EOK;
+	}
+
+	rc = inet_addr_parse_v6(text, &addr, &prefix);
+	if (rc == EOK) {
+		inet_addr_naddr(&addr, prefix, naddr);
+		return EOK;
+	}
+
+	return EINVAL;
+}
+
+static int inet_addr_format_v4(addr32_t addr, char **bufp)
+{
+	int rc;
+
+	rc = asprintf(bufp, "%u.%u.%u.%u", (addr >> 24) & 0xff,
+	    (addr >> 16) & 0xff, (addr >> 8) & 0xff, addr & 0xff);
+	if (rc < 0)
+		return ENOMEM;
+
+	return EOK;
+}
+
+static int inet_addr_format_v6(const addr128_t addr, char **bufp)
+{
+	*bufp = (char *) malloc(INET6_ADDRSTRLEN);
+	if (*bufp == NULL)
+		return ENOMEM;
+
+	/* Find the longest zero subsequence */
+
+	uint16_t zeroes[8];
+	uint16_t bioctets[8];
+
+	for (size_t i = 8; i > 0; i--) {
+		size_t j = i - 1;
+
+		bioctets[j] = (addr[j << 1] << 8) | addr[(j << 1) + 1];
+
+		if (bioctets[j] == 0) {
+			zeroes[j] = 1;
+			if (j < 7)
+				zeroes[j] += zeroes[j + 1];
+		} else
+			zeroes[j] = 0;
+	}
+
+	size_t wildcard_pos = (size_t) -1;
+	size_t wildcard_size = 0;
+
+	for (size_t i = 0; i < 8; i++) {
+		if (zeroes[i] > wildcard_size) {
+			wildcard_pos = i;
+			wildcard_size = zeroes[i];
+		}
+	}
+
+	char *cur = *bufp;
+	size_t rest = INET6_ADDRSTRLEN;
+	bool tail_zero = false;
+	int ret;
+
+	for (size_t i = 0; i < 8; i++) {
+		if ((i == wildcard_pos) && (wildcard_size > 1)) {
+			ret = snprintf(cur, rest, ":");
+			i += wildcard_size - 1;
+			tail_zero = true;
+		} else if (i == 0) {
+			ret = snprintf(cur, rest, "%" PRIx16, bioctets[i]);
+			tail_zero = false;
+		} else {
+			ret = snprintf(cur, rest, ":%" PRIx16, bioctets[i]);
+			tail_zero = false;
+		}
+
+		if (ret < 0)
 			return EINVAL;
-		
-		naddr->addr = (buf[0] << 24) | (buf[1] << 16) | (buf[2] << 8) |
-		    buf[3];
-		naddr->prefix = prefix;
-		
-		break;
-	case ip_v6:
-		prefix = strtoul(slash, &slash, 10);
-		if (prefix > 128)
-			return EINVAL;
-		
-		memcpy(naddr->addr6, buf, 16);
-		naddr->prefix = prefix;
-		
-		break;
-	default:
-		return ENOTSUP;
-	}
-	
+
+		cur += ret;
+		rest -= ret;
+	}
+
+	if (tail_zero)
+		(void) snprintf(cur, rest, ":");
+
 	return EOK;
 }
@@ -446,29 +563,24 @@
 int inet_addr_format(const inet_addr_t *addr, char **bufp)
 {
-	int rc = 0;
-	
+	int rc;
+
+	rc = ENOTSUP;
+
 	switch (addr->version) {
 	case ip_any:
 		rc = asprintf(bufp, "none");
+		if (rc < 0)
+			return ENOMEM;
+		rc = EOK;
 		break;
 	case ip_v4:
-		rc = asprintf(bufp, "%u.%u.%u.%u", (addr->addr >> 24) & 0xff,
-		    (addr->addr >> 16) & 0xff, (addr->addr >> 8) & 0xff,
-		    addr->addr & 0xff);
+		rc = inet_addr_format_v4(addr->addr, bufp);
 		break;
 	case ip_v6:
-		*bufp = (char *) malloc(INET6_ADDRSTRLEN);
-		if (*bufp == NULL)
-			return ENOMEM;
-		
-		return inet_ntop(AF_INET6, addr->addr6, *bufp, INET6_ADDRSTRLEN);
-	default:
-		return ENOTSUP;
-	}
-	
-	if (rc < 0)
-		return ENOMEM;
-	
-	return EOK;
+		rc = inet_addr_format_v6(addr->addr6, bufp);
+		break;
+	}
+
+	return rc;
 }
 
@@ -485,47 +597,45 @@
 int inet_naddr_format(const inet_naddr_t *naddr, char **bufp)
 {
-	int rc = 0;
-	char prefix[INET_PREFIXSTRSIZE];
-	
+	int rc;
+	char *astr;
+
+	rc = ENOTSUP;
+
 	switch (naddr->version) {
 	case ip_any:
 		rc = asprintf(bufp, "none");
+		if (rc < 0)
+			return ENOMEM;
+		rc = EOK;
 		break;
 	case ip_v4:
-		rc = asprintf(bufp, "%" PRIu8 ".%" PRIu8 ".%" PRIu8 ".%" PRIu8
-		    "/%" PRIu8, (naddr->addr >> 24) & 0xff,
-		    (naddr->addr >> 16) & 0xff, (naddr->addr >> 8) & 0xff,
-		    naddr->addr & 0xff, naddr->prefix);
-		break;
-	case ip_v6:
-		*bufp = (char *) malloc(INET6_ADDRSTRLEN + INET_PREFIXSTRSIZE);
-		if (*bufp == NULL)
+		rc = inet_addr_format_v4(naddr->addr, &astr);
+		if (rc != EOK)
 			return ENOMEM;
-		
-		rc = inet_ntop(AF_INET6, naddr->addr6, *bufp,
-		    INET6_ADDRSTRLEN + INET_PREFIXSTRSIZE);
-		if (rc != EOK) {
-			free(*bufp);
-			return rc;
-		}
-		
-		rc = snprintf(prefix, INET_PREFIXSTRSIZE, "/%" PRIu8,
-		    naddr->prefix);
+
+		rc = asprintf(bufp, "%s/%" PRIu8, astr, naddr->prefix);
 		if (rc < 0) {
-			free(*bufp);
+			free(astr);
 			return ENOMEM;
 		}
-		
-		str_append(*bufp, INET6_ADDRSTRLEN + INET_PREFIXSTRSIZE, prefix);
-		
-		break;
-	default:
-		return ENOTSUP;
-	}
-	
-	if (rc < 0)
-		return ENOMEM;
-	
-	return EOK;
+
+		rc = EOK;
+		break;
+	case ip_v6:
+		rc = inet_addr_format_v6(naddr->addr6, &astr);
+		if (rc != EOK)
+			return ENOMEM;
+
+		rc = asprintf(bufp, "%s/%" PRIu8, astr, naddr->prefix);
+		if (rc < 0) {
+			free(astr);
+			return ENOMEM;
+		}
+
+		rc = EOK;
+		break;
+	}
+
+	return rc;
 }
 
@@ -586,10 +696,4 @@
 }
 
-void inet_sockaddr_in_addr(const sockaddr_in_t *sockaddr_in, inet_addr_t *addr)
-{
-	addr->version = ip_v4;
-	addr->addr = uint32_t_be2host(sockaddr_in->sin_addr.s_addr);
-}
-
 void inet_addr_set6(addr128_t v6, inet_addr_t *addr)
 {
@@ -605,76 +709,4 @@
 }
 
-void inet_sockaddr_in6_addr(const sockaddr_in6_t *sockaddr_in6,
-    inet_addr_t *addr)
-{
-	addr->version = ip_v6;
-	addr128_t_be2host(sockaddr_in6->sin6_addr.s6_addr, addr->addr6);
-}
-
-uint16_t inet_addr_sockaddr_in(const inet_addr_t *addr,
-    sockaddr_in_t *sockaddr_in, sockaddr_in6_t *sockaddr_in6)
-{
-	switch (addr->version) {
-	case ip_v4:
-		if (sockaddr_in != NULL) {
-			sockaddr_in->sin_family = AF_INET;
-			sockaddr_in->sin_addr.s_addr = host2uint32_t_be(addr->addr);
-		}
-		break;
-	case ip_v6:
-		if (sockaddr_in6 != NULL) {
-			sockaddr_in6->sin6_family = AF_INET6;
-			host2addr128_t_be(addr->addr6, sockaddr_in6->sin6_addr.s6_addr);
-		}
-		break;
-	default:
-		assert(false);
-		break;
-	}
-
-	return ipver_af(addr->version);
-}
-
-int inet_addr_sockaddr(const inet_addr_t *addr, uint16_t port,
-    sockaddr_t **nsockaddr, socklen_t *naddrlen)
-{
-	sockaddr_in_t *sa4;
-	sockaddr_in6_t *sa6;
-
-	switch (addr->version) {
-	case ip_v4:
-		sa4 = calloc(1, sizeof(sockaddr_in_t));
-		if (sa4 == NULL)
-			return ENOMEM;
-
-		sa4->sin_family = AF_INET;
-		sa4->sin_port = host2uint16_t_be(port);
-		sa4->sin_addr.s_addr = host2uint32_t_be(addr->addr);
-		if (nsockaddr != NULL)
-			*nsockaddr = (sockaddr_t *)sa4;
-		if (naddrlen != NULL)
-			*naddrlen = sizeof(*sa4);
-		break;
-	case ip_v6:
-		sa6 = calloc(1, sizeof(sockaddr_in6_t));
-		if (sa6 == NULL)
-			return ENOMEM;
-
-		sa6->sin6_family = AF_INET6;
-		sa6->sin6_port = host2uint16_t_be(port);
-		host2addr128_t_be(addr->addr6, sa6->sin6_addr.s6_addr);
-		if (nsockaddr != NULL)
-			*nsockaddr = (sockaddr_t *)sa6;
-		if (naddrlen != NULL)
-			*naddrlen = sizeof(*sa6);
-		break;
-	default:
-		assert(false);
-		break;
-	}
-
-	return EOK;
-}
-
 /** @}
  */
Index: uspace/lib/c/generic/inet/endpoint.c
===================================================================
--- uspace/lib/c/generic/inet/endpoint.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/c/generic/inet/endpoint.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file Internet endpoint
+ */
+
+#include <inet/endpoint.h>
+#include <mem.h>
+
+void inet_ep_init(inet_ep_t *ep)
+{
+	memset(ep, 0, sizeof(*ep));
+}
+
+void inet_ep2_init(inet_ep2_t *ep2)
+{
+	memset(ep2, 0, sizeof(*ep2));
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/inet/tcp.c
===================================================================
--- uspace/lib/c/generic/inet/tcp.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/c/generic/inet/tcp.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,650 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file TCP API
+ */
+
+#include <errno.h>
+#include <fibril.h>
+#include <inet/endpoint.h>
+#include <inet/tcp.h>
+#include <ipc/services.h>
+#include <ipc/tcp.h>
+#include <stdlib.h>
+
+static void tcp_cb_conn(ipc_callid_t, ipc_call_t *, void *);
+static int tcp_conn_fibril(void *);
+
+/** Incoming TCP connection info */
+typedef struct {
+	tcp_listener_t *lst;
+	tcp_conn_t *conn;
+} tcp_in_conn_t;
+
+static int tcp_callback_create(tcp_t *tcp)
+{
+	async_exch_t *exch = async_exchange_begin(tcp->sess);
+
+	aid_t req = async_send_0(exch, TCP_CALLBACK_CREATE, NULL);
+	int rc = async_connect_to_me(exch, 0, 0, 0, tcp_cb_conn, tcp);
+	async_exchange_end(exch);
+
+	if (rc != EOK)
+		return rc;
+
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+
+	return retval;
+}
+
+int tcp_create(tcp_t **rtcp)
+{
+	tcp_t *tcp;
+	service_id_t tcp_svcid;
+	int rc;
+
+	tcp = calloc(1, sizeof(tcp_t));
+	if (tcp == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	list_initialize(&tcp->conn);
+	list_initialize(&tcp->listener);
+	fibril_mutex_initialize(&tcp->lock);
+	fibril_condvar_initialize(&tcp->cv);
+
+	rc = loc_service_get_id(SERVICE_NAME_TCP, &tcp_svcid,
+	    IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		rc = EIO;
+		goto error;
+	}
+
+	tcp->sess = loc_service_connect(EXCHANGE_SERIALIZE, tcp_svcid,
+	    IPC_FLAG_BLOCKING);
+	if (tcp->sess == NULL) {
+		rc = EIO;
+		goto error;
+	}
+
+	rc = tcp_callback_create(tcp);
+	if (rc != EOK) {
+		rc = EIO;
+		goto error;
+	}
+
+	*rtcp = tcp;
+	return EOK;
+error:
+	free(tcp);
+	return rc;
+}
+
+void tcp_destroy(tcp_t *tcp)
+{
+	if (tcp == NULL)
+		return;
+
+	async_hangup(tcp->sess);
+
+	fibril_mutex_lock(&tcp->lock);
+	while (!tcp->cb_done)
+		fibril_condvar_wait(&tcp->cv, &tcp->lock);
+	fibril_mutex_unlock(&tcp->lock);
+
+	free(tcp);
+}
+
+static int tcp_conn_new(tcp_t *tcp, sysarg_t id, tcp_cb_t *cb, void *arg,
+    tcp_conn_t **rconn)
+{
+	tcp_conn_t *conn;
+
+	conn = calloc(1, sizeof(tcp_conn_t));
+	if (conn == NULL)
+		return ENOMEM;
+
+	conn->data_avail = false;
+	fibril_mutex_initialize(&conn->lock);
+	fibril_condvar_initialize(&conn->cv);
+
+	conn->tcp = tcp;
+	conn->id = id;
+	conn->cb = cb;
+	conn->cb_arg = arg;
+
+	list_append(&conn->ltcp, &tcp->conn);
+	*rconn = conn;
+
+	return EOK;
+}
+
+int tcp_conn_create(tcp_t *tcp, inet_ep2_t *epp, tcp_cb_t *cb, void *arg,
+    tcp_conn_t **rconn)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+	sysarg_t conn_id;
+
+	exch = async_exchange_begin(tcp->sess);
+	aid_t req = async_send_0(exch, TCP_CONN_CREATE, &answer);
+	sysarg_t rc = async_data_write_start(exch, (void *)epp,
+	    sizeof(inet_ep2_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		sysarg_t rc_orig;
+		async_wait_for(req, &rc_orig);
+		if (rc_orig != EOK)
+			rc = rc_orig;
+		goto error;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		goto error;
+
+	conn_id = IPC_GET_ARG1(answer);
+
+	rc = tcp_conn_new(tcp, conn_id, cb, arg, rconn);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+error:
+	return (int) rc;
+}
+
+void tcp_conn_destroy(tcp_conn_t *conn)
+{
+	async_exch_t *exch;
+
+	if (conn == NULL)
+		return;
+
+	list_remove(&conn->ltcp);
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	sysarg_t rc = async_req_1_0(exch, TCP_CONN_DESTROY, conn->id);
+	async_exchange_end(exch);
+
+	free(conn);
+	(void) rc;
+}
+
+static int tcp_conn_get(tcp_t *tcp, sysarg_t id, tcp_conn_t **rconn)
+{
+	list_foreach(tcp->conn, ltcp, tcp_conn_t, conn) {
+		if (conn->id == id) {
+			*rconn = conn;
+			return EOK;
+		}
+	}
+
+	return EINVAL;
+}
+
+void *tcp_conn_userptr(tcp_conn_t *conn)
+{
+	return conn->cb_arg;
+}
+
+int tcp_listener_create(tcp_t *tcp, inet_ep_t *ep, tcp_listen_cb_t *lcb,
+    void *larg, tcp_cb_t *cb, void *arg, tcp_listener_t **rlst)
+{
+	async_exch_t *exch;
+	tcp_listener_t *lst;
+	ipc_call_t answer;
+
+	lst = calloc(1, sizeof(tcp_listener_t));
+	if (lst == NULL)
+		return ENOMEM;
+
+	exch = async_exchange_begin(tcp->sess);
+	aid_t req = async_send_0(exch, TCP_LISTENER_CREATE, &answer);
+	sysarg_t rc = async_data_write_start(exch, (void *)ep,
+	    sizeof(inet_ep_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		sysarg_t rc_orig;
+		async_wait_for(req, &rc_orig);
+		if (rc_orig != EOK)
+			rc = rc_orig;
+		goto error;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		goto error;
+
+	lst->tcp = tcp;
+	lst->id = IPC_GET_ARG1(answer);
+	lst->lcb = lcb;
+	lst->lcb_arg = larg;
+	lst->cb = cb;
+	lst->cb_arg = arg;
+
+	list_append(&lst->ltcp, &tcp->listener);
+	*rlst = lst;
+
+	return EOK;
+error:
+	free(lst);
+	return (int) rc;
+}
+
+void tcp_listener_destroy(tcp_listener_t *lst)
+{
+	async_exch_t *exch;
+
+	if (lst == NULL)
+		return;
+
+	list_remove(&lst->ltcp);
+
+	exch = async_exchange_begin(lst->tcp->sess);
+	sysarg_t rc = async_req_1_0(exch, TCP_LISTENER_DESTROY, lst->id);
+	async_exchange_end(exch);
+
+	free(lst);
+	(void) rc;
+}
+
+static int tcp_listener_get(tcp_t *tcp, sysarg_t id, tcp_listener_t **rlst)
+{
+	list_foreach(tcp->listener, ltcp, tcp_listener_t, lst) {
+		if (lst->id == id) {
+			*rlst = lst;
+			return EOK;
+		}
+	}
+
+	return EINVAL;
+}
+
+void *tcp_listener_userptr(tcp_listener_t *lst)
+{
+	return lst->lcb_arg;
+}
+
+int tcp_conn_wait_connected(tcp_conn_t *conn)
+{
+	fibril_mutex_lock(&conn->lock);
+	while (!conn->connected && !conn->conn_failed && !conn->conn_reset)
+		fibril_condvar_wait(&conn->cv, &conn->lock);
+
+	if (conn->connected) {
+		fibril_mutex_unlock(&conn->lock);
+		return EOK;
+	} else {
+		assert(conn->conn_failed || conn->conn_reset);
+		fibril_mutex_unlock(&conn->lock);
+		return EIO;
+	}
+}
+
+int tcp_conn_send(tcp_conn_t *conn, const void *data, size_t bytes)
+{
+	async_exch_t *exch;
+	sysarg_t rc;
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	aid_t req = async_send_1(exch, TCP_CONN_SEND, conn->id, NULL);
+
+	rc = async_data_write_start(exch, data, bytes);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	return rc;
+}
+
+
+int tcp_conn_send_fin(tcp_conn_t *conn)
+{
+	async_exch_t *exch;
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	sysarg_t rc = async_req_1_0(exch, TCP_CONN_SEND_FIN, conn->id);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
+int tcp_conn_push(tcp_conn_t *conn)
+{
+	async_exch_t *exch;
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	sysarg_t rc = async_req_1_0(exch, TCP_CONN_PUSH, conn->id);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
+int tcp_conn_reset(tcp_conn_t *conn)
+{
+	async_exch_t *exch;
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	sysarg_t rc = async_req_1_0(exch, TCP_CONN_RESET, conn->id);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
+int tcp_conn_recv(tcp_conn_t *conn, void *buf, size_t bsize, size_t *nrecv)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+
+	fibril_mutex_lock(&conn->lock);
+	if (!conn->data_avail) {
+		fibril_mutex_unlock(&conn->lock);
+		return EAGAIN;
+	}
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	aid_t req = async_send_1(exch, TCP_CONN_RECV, conn->id, &answer);
+	int rc = async_data_read_start(exch, buf, bsize);
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		fibril_mutex_unlock(&conn->lock);
+		return rc;
+	}
+
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	if (retval != EOK) {
+		fibril_mutex_unlock(&conn->lock);
+		return retval;
+	}
+
+	*nrecv = IPC_GET_ARG1(answer);
+	fibril_mutex_unlock(&conn->lock);
+	return EOK;
+}
+
+int tcp_conn_recv_wait(tcp_conn_t *conn, void *buf, size_t bsize, size_t *nrecv)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+
+again:
+	fibril_mutex_lock(&conn->lock);
+	while (!conn->data_avail) {
+		fibril_condvar_wait(&conn->cv, &conn->lock);
+	}
+
+	exch = async_exchange_begin(conn->tcp->sess);
+	aid_t req = async_send_1(exch, TCP_CONN_RECV_WAIT, conn->id, &answer);
+	int rc = async_data_read_start(exch, buf, bsize);
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		if (rc == EAGAIN) {
+			conn->data_avail = false;
+			fibril_mutex_unlock(&conn->lock);
+			goto again;
+		}
+		fibril_mutex_unlock(&conn->lock);
+		return rc;
+	}
+
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	if (retval != EOK) {
+		if (rc == EAGAIN) {
+			conn->data_avail = false;
+		}
+		fibril_mutex_unlock(&conn->lock);
+		return retval;
+	}
+
+	*nrecv = IPC_GET_ARG1(answer);
+	fibril_mutex_unlock(&conn->lock);
+	return EOK;
+}
+
+static void tcp_ev_connected(tcp_t *tcp, ipc_callid_t iid, ipc_call_t *icall)
+{
+	tcp_conn_t *conn;
+	sysarg_t conn_id;
+	int rc;
+
+	conn_id = IPC_GET_ARG1(*icall);
+
+	rc = tcp_conn_get(tcp, conn_id, &conn);
+	if (rc != EOK) {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+
+	fibril_mutex_lock(&conn->lock);
+	conn->connected = true;
+	fibril_condvar_broadcast(&conn->cv);
+	fibril_mutex_unlock(&conn->lock);
+
+	async_answer_0(iid, EOK);
+}
+
+static void tcp_ev_conn_failed(tcp_t *tcp, ipc_callid_t iid, ipc_call_t *icall)
+{
+	tcp_conn_t *conn;
+	sysarg_t conn_id;
+	int rc;
+
+	conn_id = IPC_GET_ARG1(*icall);
+
+	rc = tcp_conn_get(tcp, conn_id, &conn);
+	if (rc != EOK) {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+
+	fibril_mutex_lock(&conn->lock);
+	conn->conn_failed = true;
+	fibril_condvar_broadcast(&conn->cv);
+	fibril_mutex_unlock(&conn->lock);
+
+	async_answer_0(iid, EOK);
+}
+
+static void tcp_ev_conn_reset(tcp_t *tcp, ipc_callid_t iid, ipc_call_t *icall)
+{
+	tcp_conn_t *conn;
+	sysarg_t conn_id;
+	int rc;
+
+	conn_id = IPC_GET_ARG1(*icall);
+
+	rc = tcp_conn_get(tcp, conn_id, &conn);
+	if (rc != EOK) {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+
+	fibril_mutex_lock(&conn->lock);
+	conn->conn_reset = true;
+	fibril_condvar_broadcast(&conn->cv);
+	fibril_mutex_unlock(&conn->lock);
+
+	async_answer_0(iid, EOK);
+}
+
+static void tcp_ev_data(tcp_t *tcp, ipc_callid_t iid, ipc_call_t *icall)
+{
+	tcp_conn_t *conn;
+	sysarg_t conn_id;
+	int rc;
+
+	conn_id = IPC_GET_ARG1(*icall);
+
+	rc = tcp_conn_get(tcp, conn_id, &conn);
+	if (rc != EOK) {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+
+	conn->data_avail = true;
+	fibril_condvar_broadcast(&conn->cv);
+
+	if (conn->cb != NULL && conn->cb->data_avail != NULL)
+		conn->cb->data_avail(conn);
+
+	async_answer_0(iid, EOK);
+}
+
+static void tcp_ev_urg_data(tcp_t *tcp, ipc_callid_t iid, ipc_call_t *icall)
+{
+	async_answer_0(iid, ENOTSUP);
+}
+
+static void tcp_ev_new_conn(tcp_t *tcp, ipc_callid_t iid, ipc_call_t *icall)
+{
+	tcp_listener_t *lst;
+	tcp_conn_t *conn;
+	sysarg_t lst_id;
+	sysarg_t conn_id;
+	fid_t fid;
+	tcp_in_conn_t *cinfo;
+	int rc;
+
+	lst_id = IPC_GET_ARG1(*icall);
+	conn_id = IPC_GET_ARG2(*icall);
+
+	rc = tcp_listener_get(tcp, lst_id, &lst);
+	if (rc != EOK) {
+		async_answer_0(iid, ENOENT);
+		return;
+	}
+
+	rc = tcp_conn_new(tcp, conn_id, lst->cb, lst->cb_arg, &conn);
+	if (rc != EOK) {
+		async_answer_0(iid, ENOMEM);
+		return;
+	}
+
+	if (lst->lcb != NULL && lst->lcb->new_conn != NULL) {
+		cinfo = calloc(1, sizeof(tcp_in_conn_t));
+		if (cinfo == NULL) {
+			async_answer_0(iid, ENOMEM);
+			return;
+		}
+
+		cinfo->lst = lst;
+		cinfo->conn = conn;
+
+		fid = fibril_create(tcp_conn_fibril, cinfo);
+		if (fid == 0) {
+			async_answer_0(iid, ENOMEM);
+		}
+
+		fibril_add_ready(fid);
+	}
+
+	async_answer_0(iid, EOK);
+}
+
+static void tcp_cb_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	tcp_t *tcp = (tcp_t *)arg;
+
+	async_answer_0(iid, EOK);
+
+	while (true) {
+		ipc_call_t call;
+		ipc_callid_t callid = async_get_call(&call);
+
+		if (!IPC_GET_IMETHOD(call)) {
+			/* Hangup*/
+			goto out;
+		}
+
+		switch (IPC_GET_IMETHOD(call)) {
+		case TCP_EV_CONNECTED:
+			tcp_ev_connected(tcp, callid, &call);
+			break;
+		case TCP_EV_CONN_FAILED:
+			tcp_ev_conn_failed(tcp, callid, &call);
+			break;
+		case TCP_EV_CONN_RESET:
+			tcp_ev_conn_reset(tcp, callid, &call);
+			break;
+		case TCP_EV_DATA:
+			tcp_ev_data(tcp, callid, &call);
+			break;
+		case TCP_EV_URG_DATA:
+			tcp_ev_urg_data(tcp, callid, &call);
+			break;
+		case TCP_EV_NEW_CONN:
+			tcp_ev_new_conn(tcp, callid, &call);
+			break;
+		default:
+			async_answer_0(callid, ENOTSUP);
+			break;
+		}
+	}
+out:
+	fibril_mutex_lock(&tcp->lock);
+	tcp->cb_done = true;
+	fibril_mutex_unlock(&tcp->lock);
+	fibril_condvar_broadcast(&tcp->cv);
+}
+
+/** Fibril for handling incoming TCP connection in background */
+static int tcp_conn_fibril(void *arg)
+{
+	tcp_in_conn_t *cinfo = (tcp_in_conn_t *)arg;
+
+	cinfo->lst->lcb->new_conn(cinfo->lst, cinfo->conn);
+	tcp_conn_destroy(cinfo->conn);
+
+	return EOK;
+}
+
+/** @}
+ */
